#!/bin/bash
# Copy right (c) eenos.com , EPL All right reserverved
#This script will secure he eenos web django keys, permissons and ownerships

echo "*******************************************"
echo "      Securing Eenos Web App"
echo "********************************************"

UAPP_SEC_KEY=$(date +%s+%N | sha256sum | base64 | head -c 64)
RAPP_SEC_KEY=$(date +%s+%N | sha256sum | base64 | head -c 64)
WAP_SEC_KEY=$(date +%s+%N | sha256sum | base64 | head -c 64)
if [ -f /usr/local/eenos/uapp/secretkey.py ];then
    echo -n "Changing UAPP secret key .. "
    sed -i -e "s/SECRET_KEY.*/SECRET_KEY = '$UAPP_SEC_KEY'/g" /usr/local/eenos/uapp/secretkey.py
    chmod 0640 /usr/local/eenos/uapp/secretkey.py
    echo "done"
fi

if [ -f /usr/local/eenos/rapp/secretkey.py ];then
    echo -n "Changing RAPP secret key .. "
    sed -i -e "s/SECRET_KEY.*/SECRET_KEY = '$RAPP_SEC_KEY'/g" /usr/local/eenos/rapp/secretkey.py
    chmod 0640 /usr/local/eenos/rapp/secretkey.py
    echo "done"
fi

if [ -f /usr/local/eenos/wap/secretkey.py ];then
    echo -n "Changing WAP secret key .. "
    sed -i -e "s/SECRET_KEY.*/SECRET_KEY = '$WAP_SEC_KEY'/g" /usr/local/eenos/wap/secretkey.py
    chmod 0640 /usr/local/eenos/wap/secretkey.py
    echo "done"
fi

if [ -f /usr/local/eenos/uapp/debugsettings.py ];then
    echo -n "Disabling Debug on UAPP .. "
    sed -i -e "s/DEBUG.*/DEBUG = False/g"  /usr/local/eenos/uapp/debugsettings.py 
    echo "done"   

fi
if [ -f /usr/local/eenos/rapp/debugsettings.py ];then
    echo -n "Disabling Debug on RAPP .. "
    sed -i -e "s/DEBUG.*/DEBUG = False/g"  /usr/local/eenos/rapp/debugsettings.py 
    echo "done"   

fi
if [ -f /usr/local/eenos/wap/debugsettings.py ];then
    echo -n "Disabling Debug on WAP .. "
    sed -i -e "s/DEBUG.*/DEBUG = False/g"  /usr/local/eenos/wap/debugsettings.py 
    echo "done"   

fi
echo "== Running migrations  on UAPP ...."
if [ -f /usr/local/eenos/uapp/eenos-uapp.db ] ;then    
    /usr/local/eenos/bin/python3 /usr/local/eenos/uapp/manage.py migrate
    chmod 0640 /usr/local/eenos/uapp/eenos-uapp.db
else
    /usr/local/eenos/bin/python3 /usr/local/eenos/uapp/manage.py makemigrations
    /usr/local/eenos/bin/python3 /usr/local/eenos/uapp/manage.py migrate
    chmod 0640 /usr/local/eenos/uapp/eenos-uapp.db
fi
echo "== Running migrations  on RAPP ...."
if [ -f /usr/local/eenos/rapp/eenos-rapp.db ] ;then   
    /usr/local/eenos/bin/python3 /usr/local/eenos/rapp/manage.py migrate
    chmod 0640 /usr/local/eenos/rapp/eenos-rapp.db
else
    /usr/local/eenos/bin/python3 /usr/local/eenos/rapp/manage.py makemigrations
    /usr/local/eenos/bin/python3 /usr/local/eenos/rapp/manage.py migrate
    chmod 0640 /usr/local/eenos/rapp/eenos-rapp.db
fi
echo "== Running migrations  on WAP ...."
if [ -f /usr/local/eenos/wap/eenos-wap.db ] ;then    
    /usr/local/eenos/bin/python3 /usr/local/eenos/wap/manage.py migrate
    chmod 0640 /usr/local/eenos/wap/eenos-wap.db
else
    /usr/local/eenos/bin/python3 /usr/local/eenos/wap/manage.py makemigrations
    /usr/local/eenos/bin/python3 /usr/local/eenos/wap/manage.py migrate
    chmod 0640 /usr/local/eenos/wap/eenos-wap.db
fi

if [ -d /usr/local/eenos/uapp ];then
    echo -n "Setting ownerships on uapp .."
    chown -R eenos:eenos /usr/local/eenos/uapp
    echo "done"
fi

if [ -d /usr/local/eenos/rapp ];then
    echo -n "Setting ownerships on rapp .."
    chown -R eenos:eenos /usr/local/eenos/rapp
    echo "done"
fi
if [ -d /usr/local/eenos/wap ];then
    echo -n "Setting ownerships on WAP .."
    chown -R root:root /usr/local/eenos/wap
    echo "done"
fi
echo -n "== Restarting eenos web services .. "
/usr/bin/systemctl restart eenosweb.service 
echo "done"